mob	//define everything past this point to derived from /mob
	proc/ai()	//define a proc called ai(), although make it do nothing. We dont want players being able to use a proc based on artificial
				//intellegence. Thats for computer based mobs alone.

	proc/attack(mob/m)	//Define a proc called attack(), and allow mob/m as an arguement.
		show_hit(m)	//Make attack activate the show_hit() proc with m as the arguement passed.

	proc/show_hit(mob/m)	//Define a proc called show_hit(), and allow mob/m as an arguement
		var/obj/Hit = new/obj/HitShow	//Define a variable derived from /obj and name it hit. Then set it to a new instance of the object "HitShow"
		Hit.pixel_x += rand(-2,2)	//Set the variable object Hit's pixel_x to add a random ammount of -2 to 2
		Hit.pixel_y += rand(-2,2)	//Set the variable object Hit's pixel_y to add a random ammount of -2 to 2
		Hit.mouse_opacity = 0	//Set the variable object Hit's mouse_opacity(built in) variable to 0, this makes it so when you click it, it will
								//effect the object/mob/turf under it, and not the object. After all we dont want to attack an object used to show
								//someone is getting hit, do we?
		Hit.dir = pick(NORTH, SOUTH, EAST, WEST)	//Use the built in "pick(ThingsToPickFrom1,ThingsToPickFrom2,etc)" proc to set the variable
													//object Hit's dir(Direction) variable to north, south, east, or west. This is to change what
													//the objects apperence looks like.
		m.overlays += Hit	//add the variable object Hit to m's(the mob who was passed through the last few procs as an arguement) overlays
		sleep(4)	//the built sleep() works alot like spawn(), however(in this case) instead of waiting four ticks then spawning the
					//next part of the proc, sleep will pause the proc for four ticks, then play the proc.
		m.overlays -= Hit	//remove the bariable object Hit from m's overlays
		del Hit //delete the variable object Hit

	ai	//Define the ai mob type derived from /mob, and have everythign past it derived from /mob/ai
		var/mob/target = null	//Define the variable that will contain a mob as a target and set it to null(No Target)

		New()	//Use the built in New() proc to alter how all mobs derived from /mob/ai will be created
			..()	//use the default New() procedure
			spawn(2) ai()	//use spawn to spawn the ai() proc in 2 ticks

		ai()	//Overwrite the overall ai() proc derived from /mob and give it a new procedure from mobs derived from /mob/ai
			if(target)	//check if the src(the mob derived from /mob/ai using the ai() proc) has a target
				chase_target()	//if it does have a target, use the chase_target() proc
			else	//if the src mob does not have a target
				get_target()	//use the get_target() proc to attempt to find it a target
				if(target)	//if it now has a target from finding one
					sleep(1)	//pause the proc for one tick
				else	//if it still doesnt have a target
					step(src, pick(EAST,WEST,NORTH,SOUTH))	//make it step randomly. Normally we would use the built in step_rand(mob) to make it
															//randomly step but ever since the more dynamic pixel_movement system update,
															//step_rand(mob) seems to only make a mob move south. So we will use the built in
															//step(mob, direction) proc to make it step randomly. We also use the built in pick()
															//proc again to pick a random direction.
			spawn(2) ai()	//wait 2 ticks then repeat the ai() proc again

		proc	//Define everything past this point as a custom proc derived from /mob/ai
			chase_target()	//Define the chase_target() proc for all mobs derived from /mob/ai
				if(target)	//check if the src(the mob derived from /mob/ai using the chase_target() proc) has a target
					if(get_dist(src, target) > 1)	//if it does check the distance between the src and the target with the built in
													//get_dist(Spot1, Spot2) proc, then check if its more than one.
						step_to(src, target)	//If the distance is more than one, use the built in step_to(MobToMove, MobToMoveto) proc
												//to step torwards the target
						sleep(2)	//pause the proc for 2 ticks using the built in sleep() proc
					else	//if the distance between the src and target was less than 1
						attack(target)	//have the src use the custom attack() proc with the target as an arguement
						sleep(1)	//pause the proc from one tick using the built in sleep() proc

			get_target()	//Define the get_target() proc for all mobs derived from /mob/ai
				for(var/mob/m in oview(2, src))	//use a for loop to check for all mobs(we use the variable var/mob/m for this) within 2 spaces
												//outwards in all directions from the src. To do this we use the built in
												//oview(Distance, Mob/Object/Turf) proc.
					if(!m.key)	//we want the default get_target() proc to not target players, so we check if the m(the mob found) has a key, and
								//we only continue if it does not.
						if(m != src)	//we dont want the mob to attack itself, so we make sure m is not the src, and only continue if it isnt.
							target = m	//we then set the src's target to m


		Hostile	//Define the Hostile mob derived from /mob/ai
			icon_state = "Hostile"	//Define all mobs derived from /mob/ai/Hostile to use the icon_state "Hostile"

			get_target()	//Define all mobs derived from /mob/ai/Hostile to use a different version of the get_target() proc
				for(var/mob/m in oview(5, src))	//use a for loop to check for all mob(we use the bariable var/mob/m for this) within 5 spaces
												//outwards in all directions from the src using the oview() proc.
					if(m != src)	//we allow hostile ais to attack players, so skipping that step we check if m(the mob found) is the source,
									//since we dont want it attacking itself.
						target = m	//we then set the target to m if it isnt the src
		Friendly	//Define the Friendly mob derived from /mob/ai
			icon_state = "Friendly"	//Define all mobs derived from /mob/ai/Friendly to use the icon_state "Friendly"
